# Extended Data

### Extended Data Fig. 1: Flow chart of experimental procedures.
**a**, Overview of experiments and type of analyses performed on root, rhizosphere, and soil samples, or millifluidic droplets. **b**, Culture collection establishment of *Lotus japonicus* root and nodule bacterial isolates. Image created with BioRender.com.

https://www.nature.com/articles/s41564-021-00941-9/figures/7

### Extended Data Fig. 2 Culture-independent diversity analysis of root-associated bacterial communities from *Lotus* and *Arabidopsis*.
Rank abundance plot of bacterial communities from *Lotus* or *Arabidopsis* roots, aggregated to the class level, including all families with a mean accumulated relative abundance of > 0.1% on either host. Statistical differences were assessed using a two-sided, non-parametric Mann–Whitney test. Asterisks represent significant values after multiple testing correction using the Benjamini–Hochberg method (*P* < 0.05).

https://www.nature.com/articles/s41564-021-00941-9/figures/8

### Extended Data Fig. 3 Functional overlap of *Lotus* and *Arabidopsis* culture collection genomes.
PCoA of functional distances of genomes from bacterial isolates of the *Lotus* (*Lj*-SPHERE; n = 294) and the *Arabidopsis* (*At*-SPHERE; n = 194) culture collections.

https://www.nature.com/articles/s41564-021-00941-9/figures/9

### Extended Data Fig. 4 Host-species specific bacterial root communities and commensal host preference is confirmed using independent mixed communities.
**a** and **c**, Constrained PCoA of Bray-Curtis dissimilarity (constrained by all biological factors and conditioned by all technical variables) of soil, rhizosphere, and root samples from *L. japonicus* wild-type Gifu, *nfr5* mutant, and *A. thaliana* wild type Col-0 plants co-cultivated with the mixed community *LjAt*-SC1 (**a**, experiment C, n = 155, variance explained 53.8%, *P* = 0.001), from Gifu and Col-0 co-cultivated with *LjAt*-SC4 (**b**, experiment D, n = 87, variance explained 60%, *P* = 0.001), or from Gifu and Col-0 co-cultivated with *LjAt*-SC5 (**b**, experiment M, n = 100, variance explained 67%, *P* = 0.001). **d**, **e** and **f**, Aggregated RA of the 16 *Lj*-derived and the 16 *At*-derived strains in the roots of *Lotus* and *Arabidopsis* plants inoculated with *LjAt*-SC1 (**d**; n = 68), *LjAt*-SC4 (**e**; n = 34), or *LjAt*-SC5 (**f**; n = 40). n refers to biologically independent samples.

https://www.nature.com/articles/s41564-021-00941-9/figures/10

### Extended Data Fig. 5 Host preference is retained after in silico removal of individual bacterial families.
Aggregated relative abundance of *Lotus*- (**a**, n = 20) and *Arabidopsis*-derived (**b**, n = 16) strains in roots from plants inoculated with the mixed community *LjAt*-SC3 (experiment L). Host preference was assessed using a Mann-Whitney non-parametric test after *in silico* removal of each family. The x-axis labels indicate each depleted family. n refers to biologically independent samples.

https://www.nature.com/articles/s41564-021-00941-9/figures/11

### Extended Data Fig. 6 Bacterial abundance in mono-association with host plants.
Bacterial abundances of commensal bacteria (strain IDs indicated at x-axis) colonizing Col-0, Gifu, and *nfr5* roots, assessed by counting of colony forming units (CFUs) after extraction from root tissue. Plants were grown for two weeks on agar plates in mono-association with the indicated Lj-SPHERE (**a**) and At-SPHERE (**b**) strains (exp. E). n = 6 (3 biologically independent samples × 2 technical replicates). Statistical differences were assessed using a two-sided, non-parametric Mann-Whitney test. Asterisks represent significant values after multiple testing correction using the Benjamini–Hochberg method (*P* < 0.05).

https://www.nature.com/articles/s41564-021-00941-9/figures/12

### Extended Data Fig. 7 Plant performance in mono-associations.
Shoot fresh weight of Gifu (**a**) and Col-0 (**b**) plants grown for two weeks on agar plates in mono-association with the indicated *Lj*-SPHERE and *At*-SPHERE strains (exp. E). n = 30 (3 biologically independent samples × 10 technical replicates).

https://www.nature.com/articles/s41564-021-00941-9/figures/13

### Extended Data Fig. 8 Sister species of *L. japonicus* and *A. thaliana* establish distinct bacterial root communities.
Constrained PCoA of Bray-Curtis dissimilarity (constrained by all biological factors and conditioned by all technical variables) of root samples from *L. japonicus* wild type Gifu and *L. corniculatus* (**a**; n = 87; variance explained 58.7%, *P* = 0.001), and or root samples from *A. thaliana* wild type Col-0 and *A. lyrata* MN47 (**b**; n = 86; variance explained 65%, *P* = 0.001), inoculated and grown with the mixed community *LjAt*-SC3, and of the corresponding rhizosphere and bulk soil communities (exp. F).

https://www.nature.com/articles/s41564-021-00941-9/figures/14

### Extended Data Fig. 9 Tested plant immune receptors and signaling pathways do not affect host preference of commensals.
**a**, Constrained PCoA of Bray-Curtis dissimilarity (constrained by all biological factors and conditioned by all technical variables; n = 98; variance explained 24.6%, *P* = 0.001) of root samples from *L. japonicus* wild type Gifu, *Ljfls2* mutant, *A. thaliana* wild type Col-0, *Atfls2* mutant, and *Atbbc* mutant inoculated and grown with the mixed SynCom *LjAt*-SC1 (exp. G), and of the corresponding bacterial input communities. **b**, Aggregated relative abundance of the 16 *Lj*-derived and the 16 *At*-derived strains in the roots of *Lotus* and *Arabidopsis* plants. n = 21 for Gifu, n = 16 for Col-0, n = 20 for *Ljfls2* and *Atfls2*, n = 18 for *Atbbc*. **c**, Constrained PCoA of Bray-Curtis dissimilarity (constrained by all biological factors and conditioned by all technical variables; n = 64; variance explained 42.2%, *P* = 0.001) of soil and root samples from Gifu, Col-0, and *Atdeps* mutant inoculated and grown with the mixed SynCom *LjAt*-SC3 (exp. H). **d**, Aggregated relative abundance of the 16 *Lj*-derived and the 16 *At*-derived strains in the roots of *Lotus* and *Arabidopsis* plants. n = 14 for Gifu, n = 20 for Col-0 and *Atdeps*. n refers to biologically independent samples.

https://www.nature.com/articles/s41564-021-00941-9/figures/15

### Extended Data Fig. 10 Effect of secreted indole glucosinolates on host preference of commensals.
**a**, Constrained PCoA of Bray-Curtis dissimilarity (constrained by all biological factors and conditioned by all technical variables; n = 50; variance explained 47.2%, *P* = 0.001) of soil and root samples from *L. japonicus* wild type Gifu, *A. thaliana* wild type Col-0, and *Arabidopsis cyp79b2 cyb79b3* mutant inoculated and grown with the mixed SynCom *LjAt*-SC3 (exp. H). **b**, Aggregated relative abundance of the 16 *Lj*-derived and the 16 *At*-derived strains in the roots of *Lotus* and *Arabidopsis* plants. n = 20 for Col-0, n = 14 for Gifu, n = 6 for *Atcyp79b2b3*. n refers to biologically independent samples.

https://www.nature.com/articles/s41564-021-00941-9/figures/16